package org.netkernel.scheduler;

import java.io.IOException;
import java.util.concurrent.Semaphore;

import org.netkernel.request.IExpiry;
import org.netkernel.request.IRequest;
import org.netkernel.request.IResponse;
import org.netkernel.request.IResponseMeta;
import org.netkernel.request.impl.RequestImpl;
import org.netkernel.request.impl.RequestResponseFieldsImpl;

/** A Request State that will hold on to the worker thread and load up the cpu on demand
 * - used for experimental thread/cpu core affinity testing
 * @author tab
 *
 */
public class ProfileThreadState implements IRequestState
{
	private Thread mThread;
	private boolean mReleased;
	private Semaphore mSemaphore1=new Semaphore(0);
	private Semaphore mSemaphore2=new Semaphore(0);
	public int mK;
	
	public void processRequest()
	{	mThread=Thread.currentThread();
		try
		{	while (!mReleased)
			{			
				mSemaphore1.acquire();
				if (!mReleased)
				{	//load up the cpu
					int k=0;
					for (int i=0; i<40000; i++)
					{	for (int j=0; j<i; j++)
						{	mK+=j;
						}
					}
					mSemaphore2.release();
				}
				
			}	
		}
		catch (Exception e)
		{
		}
	}
	
	/** Free up the worker thread
	 */
	public void release()
	{	mReleased=true;
		mSemaphore1.release();
	}
	
	/** Load up the CPU
	 */
	public void work()
	{	mSemaphore1.release();
	}
	
	/** Wait for CPU loading to complete
	 * @throws InterruptedException
	 */
	public void waitForWork() throws InterruptedException
	{	mSemaphore2.acquire();
	}
	
	public void declareSubrequestIssue(IRequestState substate)
	{
	}

	public void declareSubrequestResponse(IRequestState substate)
	{
	}

	public IRequest getRequestIn()
	{	return new RequestImpl(0, null, null, null, null, null, new RequestResponseFieldsImpl(0), new Object[0]);
	}

	public RootState getRoot()
	{
		return null;
	}

	public void resumeTimer()
	{
	}

	public boolean isComplete()
	{	return true;
	}

	public IInternalResponseMeta getResponseMeta()
	{	return null;
	}
	
	public IRequestState getParent()
	{	return null;
	}	

}
